;==============   ==================
;ATtiny2313 4 

.include "tn2313def.inc"

;====   ====
.equ	segA = 5 ; PD5 (pin 9)
.equ	segB = 6 ; PD6 (pin 11)
.equ	segC = 2 ; PB2 (pin 14)
.equ	segD = 4 ; PB4 (pin 16)
.equ	segE = 5 ; PB5 (pin 17)
.equ	segF = 6 ; PB6 (pin 18)
.equ	segG = 7 ; PB7 (pin 19)

;====   ====
.equ	em = 0 ;  PD0 (pin2)
.equ	dm = 1 ;  PD1 (pin3)
.equ	eh = 2 ;  PD2 (pin6)
.equ	dh = 4 ;  PD4 (pin8)

;====   ====
.def	POS	= r16 ;    
.def	sek	= r17 ; 
.def	temp	= r18 ; 
.def	emin	= r19 ;  
.def	dmin	= r20 ;  
.def	ehh	= r21 ;  
.def	dhh	= r22 ;  
.def	set_up	= r23 ;   
.def	count	= r24 ;  
.def	Flag	= r25 ; 

;  Flag:  0=1,    
; 1=1,    

;========  =========
rjmp RESET ; Reset 
reti;	 
rjmp INTT1 ; INT1   1
reti;	 
rjmp TIM1 ; Timer1   CompareA ( )
reti;	 
rjmp TIM0 ; Timer0   (. )
reti;	 
reti;	 
reti;	 
rjmp ACOMPI ;  
nop;	 
nop;	 
nop;	 
nop;	 
nop;	 
nop;	 
nop;	 
nop;	 

;==========  ================
;=====     1 ====
INTT1:
	sbrc Flag,1 ; 1=1  
	reti ;    -  
	clr temp
	out GIMSK,temp ; INT1
	sbr Flag,1 ;  0  -  
	inc set_up ;,   
	clr count ;  
	cpi set_up,5 ;  
	brne END_SET ;   4,   
	clr set_up ; ,   
	ldi sek,59 ;    = 59
	cbr Flag,1 ;  0  -  
END_SET:
reti ;  INT1

;=====  Timer1 -   ====
TIM1:
	sbrc Flag,1 ; 1=1  
	rjmp mtime ;    
	sbrs Flag,0 ; 0=1  
	rjmp mtime ;    

	ldi temp,0b10000000 ;  
	out GIFR,temp ; e INT1
	cpi count,0 ;  =0
	breq CONT_1 ;  
	ldi temp,1<<INT1 ;   INT1
out GIMSK,temp

CONT_1: ;
	inc count  ;    1
	cpi set_up,1 ;  ,  
	brne mm1 ;  
	sbis PinB,1 ; 2 
	inc emin ;     1
	cpi emin,10 ;       10
	brne END_TIM1 ;    
	clr emin ; =10,  
	reti ; 
mm1: cpi set_up,2 ;  ,  
	brne mm2 ;  
	sbis PinB,1 ; 2 
	inc dmin ;     1
	cpi dmin,6 ;       6
	brne END_TIM1 ;    
	clr dmin ; =6,  
	reti ; 
mm2: cpi set_up,3   ;  ,  
	brne mm3 ;  
	sbis PinB,1 ; 2 
	inc ehh ;     1
	cpi ehh,4 ;      4
	brlo END_TIM1 ;    
	cpi dhh,2 ;      2 
	brne mm21 ;   mm21
	clr ehh ;    
	reti ;  
mm21: cpi ehh,10 ;      10
	brne END_TIM1 ;  
	clr ehh ;     
	reti ; 
mm3:  sbis PinB,1 ; 
	inc dhh ;     1
	cpi dhh,3 ;     3
	brne END_TIM1 ;  
	clr dhh ;  
	reti ; 

	; 
mtime:  inc sek ;    1
	cpi sek,60 ;    60
	brne END_TIM1 ;  

	clr sek ;  
	inc emin ;   
	cpi emin,10 ;      10
	brne END_TIM1 ;  

	clr emin ;   
	inc dmin ;    
	cpi dmin,6 ;    6
	brne END_TIM1 ;  

	clr dmin ;    
	inc ehh ;    
	cpi ehh,4 ;      4
	brlo END_TIM1 ;   
	cpi dhh,2 ;        2
	brne mhh ;   mhh 
	clr ehh ;    
	clr dhh ;      ( )
	rjmp END_TIM1 ; 
mhh:
	cpi ehh,10 ;      10
	brne END_TIM1 ; 
	clr ehh ;   
	inc dhh ;   

END_TIM1:
reti ;   Timer1

;=====  Timer0   =====
TIM0: 
	sbrc Flag,1 ; 1=1  
	rjmp END_TIM0 ;   

	clr temp ; 
	out PortD,temp
	out PortB,temp
	
	andi POS,3 ;   0  3 

	sbis PinB,1 ;   2
	clr count;     

	cpi POS,0 ;    0
	brne m0 ;   m0 -  
	cpi set_up,1 ;  set_up=1,   
	brne sm_1 ;   
	sbrs count,0 ;  0  count=0
sm_1:  sbi PortD,em ; . PD0  1,    
	;   ,      count
	mov temp,emin ; temp -   
	rcall SEG_SET ; 
	rjmp END_0 ;  

m0:	cpi POS,1 ;    1
	brne m1 ;  . 
	cpi set_up,2 ; set_up=2    
	brne sm_2 ;    
	sbrs count,0 ;  0  count=0
sm_2:  sbi PortD,dm ; . PD1  1,    
	mov temp,dmin ; temp -   
	rcall SEG_SET ; 
	rjmp END_0 ;  

m1:    cpi POS,2 ;    2
	brne m2 ;  . 
	cpi set_up,3 ; set_up=3    
	brne sm_3 ;    
	sbrs count,0 ;  0  count=0
sm_3:  sbi PortD,eh ; . PD2  1,    
	mov temp,ehh ; temp -   
	rcall SEG_SET ; 
	rjmp END_0 ;  

m2: ; 4   	
	cpi set_up,4  ; set_up=4    
	brne sm_4 ;   
	sbrs count,0 ;  0  count=0
sm_4:  sbi PortD,dh ; . PD4  1,    
	mov temp,dhh ; temp -   
	rcall SEG_SET ; 

END_0:
	inc POS
END_TIM0:
reti ;   Timer0

;=======  -  =========
ACOMPI:
	sbis ACSR,ACO ;  ACO =1  
	rjmp COMP_1 ;   
	ldi temp,0b11000000
	out TCCR1A,temp ;   
	rjmp END_comp ; 
COMP_1: 
	ldi temp,0b01000000
	out TCCR1A,temp ;  
END_comp:
reti ;   

;===============  Reset =======================
RESET:
cli ;    
ldi temp,low(RAMEND) ;  
out SPL,temp

ldi temp,0b01110111 ; D  0,1,2,4,5,6  
out DDRD,temp
ldi temp, 0b11111100 ;    ,  0,1 ()
out DDRB,temp

;----   ----
ldi temp,0b00000010 ;  Timer0   1:8 
out TCCR0,temp ;   , 
;  2  (4/8=0,5 /256)

ldi temp,high(62500) ; 
out OCR1AH,temp; .  1   .  1:64
ldi temp,low(62500) ; 
out OCR1AL,temp	
    
ldi temp,0b01000000
out TCCR1A,temp ;     1 (15)
ldi temp,0b01001011 ; 1/64 timer1    
out TCCR1B,temp;

;------  --------
ldi temp,1<<INT1 ;  INT1
out GIMSK,temp
ldi temp,(1<<TOIE0)|(1<<OCIE1A);.  Tim0  Tim1
out TIMSK,temp
ldi temp,(1<<ACIE) ;.    
out ACSR,temp

sei ; 

;=======   ========

G_cycle: ;      
	sbrs Flag,0 ; 0=1  
	rjmp G_cycle ; ,    
	sbic PinB,0 ;  
	rcall Restore ;   
	sbis PinB,0 ;  
	rcall Disable ;   
rjmp G_cycle ; 

;=======    ========

Disable: ; 
	sbrc Flag,2 ; 1=1    
	rjmp END_dis ;  
	cli ;    
	sbr Flag,2 ;  1 Flag
	;      :
	clr temp
	out PortD,temp
	out PortB,temp
	out DDRD,temp
	out DDRD,temp
	sei ; 
END_dis:
ret ;   

Restore: ;  
	sbrs Flag,2 ; 1=0     
	rjmp end_res ;  
	;
	cli ;    
	cbr Flag,2 ; 1 Flag
	;  :
	clr temp
	ldi temp,0b01110111 ; D  0,1,2,4,5,6  
	out DDRD,temp
	ldi temp, 0b11111100 ;    ,  0,1 
	out DDRB,temp
	sei ; 
END_res:
ret ;    

SEG_SET: ;   
	cpi temp,0 ; ,  temp
	brne ss_0
	rcall OUT_0 ;      
	rjmp END_seg 
ss_0:	cpi temp,1
	brne ss_1
	rcall OUT_1
	rjmp END_seg 
ss_1:	cpi temp,2
	brne ss_2
	rcall OUT_2
	rjmp END_seg 
ss_2:	cpi temp,3
	brne ss_3
	rcall OUT_3
	rjmp END_seg 
ss_3:	cpi temp,4
	brne ss_4
	rcall OUT_4
	rjmp END_seg 
ss_4:	cpi temp,5
	brne ss_5
	rcall OUT_5
	rjmp END_seg 
ss_5:	cpi temp,6
	brne ss_6
	rcall OUT_6
	rjmp END_seg 
ss_6:	cpi temp,7
	brne ss_7
	rcall OUT_7
	rjmp END_seg 
ss_7:	cpi temp,8
	brne ss_8
	rcall OUT_8
	rjmp END_seg 
ss_8:	cpi temp,9
	rcall OUT_9
END_seg:
ret ;   
;      
;ABCDEF(0);BC(1);ABDEG(2);ABCDG(3);BCFG(4);ACDFG(5)
;ACDEFG(6);ABC(7);ABCDEFG(8);ABCDFG(9)
OUT_0:
	sbi PortD,segA
	sbi PortD,segB
	sbi PortB,segC
	sbi PortB,segD
	sbi PortB,segE
	sbi PortB,segF
	ret
OUT_1:
	sbi PortD,segB
	sbi PortB,segC
	ret
OUT_2:
	sbi PortD,segA
	sbi PortD,segB
	sbi PortB,segG
	sbi PortB,segE
	sbi PortB,segD
	ret
OUT_3:
	sbi PortD,segA
	sbi PortD,segB
	sbi PortB,segG
	sbi PortB,segC
	sbi PortB,segD
	ret
OUT_4:
	sbi PortD,segB
	sbi PortB,segC
	sbi PortB,segF
	sbi PortB,segG
	ret
OUT_5:
	sbi PortD,segA
	sbi PortB,segF
	sbi PortB,segG
	sbi PortB,segC
	sbi PortB,segD
	ret
OUT_6:
	sbi PortD,segA
	sbi PortB,segF
	sbi PortB,segG
	sbi PortB,segC
	sbi PortB,segE
	sbi PortB,segD
	ret
OUT_7:
	sbi PortD,segA
	sbi PortD,segB
	sbi PortB,segC
	ret
OUT_8:
	sbi PortD,segA
	sbi PortD,segB
	sbi PortB,segC
	sbi PortB,segD
	sbi PortB,segE
	sbi PortB,segF
	sbi PortB,segG
	ret
OUT_9:
	sbi PortD,segA
	sbi PortD,segB
	sbi PortB,segC
	sbi PortB,segD
	sbi PortB,segF
	sbi PortB,segG
	ret
